require 'lib/announce'
require 'lib/day'
require 'lib/map'

class Disaster
  @@list = [:random, :brother_marriage,:brother_car,:price_double]
  @@random = ["Emu prices have skyrocketed!","Emu prices have bottomed out","Emu is worthless...for now"]
  @@state = {}
  
  def Disaster.state(var)
    @@state[var]
  end
  
  def Disaster.occur
    method = @@list[(rand *@@list.size).to_i]
    message,profit = *Disaster.send(method)
    Announce.instance.announce(message,profit,5)
    Day.add_task(Day.day+1,Proc.new { Disaster.occur })
  end
  
  def Disaster.random
    return [@@random[(rand*@@random.size)-1],nil]
  end
  
  def Disaster.brother_marriage
    @@state[:brother_marriage] ||= 0
    
    again = ""
    cost = -50+(10000*rand).to_i/100.0
    if @@state[:brother_marriage] == 1
      again = ", again"
      cost = -(10000*rand).to_i/100.0
    elsif @@state[:brother_marriage] > 1
      cost = -(2000*rand).to_i/100.0
      again = ", \##{@@state[:brother_marriage]}"
    end
    message = "Your brother is getting married#{again}"
    
    @@state[:brother_marriage] += 1
    return [message,cost]
  end
  
  def Disaster.brother_car
    return ["Your brother borrows your car",-5000-(rand*1000).to_i]
  end
  
  def Disaster.price_double
    cities = Map.instance.cities
    city = cities[(rand*cities.size).to_i]
    good = city.prices.keys[(rand*city.prices.size).to_i]
    city.prices[good]*=2
    return ["The price of #{good} in #{city.name} has doubled",nil]
  end
end
