require 'rubygame'
require 'singleton'
require 'lib/visible'
require 'lib/settings'

class QuitOverlay
  include Singleton
  include Rubygame::Sprites::Sprite
  include Visible

  def initialize
    super
    font = Rubygame::TTF.new("res/fonts/FreeSans.ttf",24)
    @settings = Settings.instance
    @buttons = ["    Retire    ","Keep Playing"].map { |str| font.render(str,true,[20,20,20]) }
    @rect = @buttons.map { |x| x.make_rect }
    @buttons.each_with_index { |button,i|
      @rect[i].x = @settings[:width]/2 - i*(button.size[0]+10)
      @rect[i].y = @settings[:height]/2-button.size[1]/2
    }
    @alpha = [128,128]
    @visible=false
  end
  
  def buttons
    @rect
  end
  
  def mouse_at(x,y)
    @rect.each_with_index { |rect,i| @alpha[i] = (rect.collide_point?(x,y) ? 255 : 128) }
  end
  
  def update
  
  end
  
  def draw(surf)
    @buttons.each_with_index { |button,i|
      surf.draw_box_s([@rect[i].x-4,@rect[i].y-4],[@rect[i].x+@rect[i].w+4,@rect[i].y+@rect[i].height+4],[255,255,255,@alpha[i]])
      surf.draw_box([@rect[i].x-4,@rect[i].y-4],[@rect[i].x+@rect[i].w+4,@rect[i].y+@rect[i].height+4],[120,120,120,@alpha[i]])
      button.blit(surf,[@rect[i].x,@rect[i].y])
    } if visible?
  end
end
